%def_enable shared
%def_disable static

%def_with pic

%def_enable mmx
%def_enable 3dnow
%def_enable sse
%def_enable sse2
%def_disable altivec

# libavcodec & libmpeg2 must be always enabled
#def_disable libavcodec
#def_enable libmpeg2
%def_disable static_libavcodec
%def_enable postproc
%def_disable libmpeg3
%def_disable avifile
%def_enable theora
%def_enable quicktime
%def_enable mjpegtools
%def_enable libfame

%def_enable imagemagick
%def_enable jpeg

%def_enable lame
%def_enable ogg
%def_enable vorbis
%def_enable a52

%def_enable static_framebuffer
%def_enable sdl

%def_enable oss
%def_disable sunaudio

%def_enable netstream

%def_enable v4l
%def_disable bktr

%def_enable lzo

%def_enable dvd
%def_enable dv

%def_enable libxml2
%def_enable freetype
%def_enable gtk

%def_enable iconv
%def_disable ibp
%def_disable bsdav
%def_disable xio
%def_disable pvm

%def_with X11

%def_with pnmpvn
%def_with subtitleripper
%def_with showpvn_gl
%def_with showpvn_imagemagick
#----------------------------------------------------------------------
%define set_disable() %{expand:%%force_disable %{1}} %{expand:%%undefine _enable_%{1}}
%define set_without() %{expand:%%force_without %{1}} %{expand:%%undefine _with_%{1}}
%define subst_enable_to() %{expand:%%{?_enable_%{1}:--enable-%{2}}} %{expand:%%{?_disable_%{1}:--disable-%{2}}}
%define subst_with_to() %{expand:%%{?_with_%{1}:--with-%{2}}} %{expand:%%{?_without_%{1}:--without-%{2}}}

%ifnarch %ix86 x86_64
%set_disable mmx
%set_disable 3dnow
%set_disable sse
%set_disable sse2
%set_disable altivec
%endif

%ifnarch ppc
%set_disable altivec
%endif

%if_without pnmpvn
%set_without showpvn_gl
%set_without showpvn_imagemagick
%endif

Name: transcode
Version: 1.0.4
Release: alt0.1
Summary: A linux video stream processing utility
License: GPL
Group: Video
Url: http://www.transcoding.org/cgi-bin/transcode
# http://subtitleripper.sourceforge.net/
Source: http://www.jakemsr.com/transcode/%name-%version.tar.bz2
Source1: subtitleripper-0.3-4.tar.bz2
Source2: export_dvraw.c.gz
Patch0: %name-1.0.3-configure_ffmpeg.patch
# http://article.gmane.org/gmane.comp.video.transcode.user/18434
# http://article.gmane.org/gmane.comp.video.transcode.user/18381
# http://article.gmane.org/gmane.comp.video.transcode.user/18446
Patch4: tccat-CVS-iodir-backport-try1.patch.bz2
# http://sourceforge.net/projects/dirac
Patch5: %name-1.0.2-dirac-0.5.x.patch.gz
# subtitleripper patches
Patch101: subtitleripper-0.3-4-spudec.patch.gz
Patch102: subtitleripper-0.3-4-makefile.patch.gz

# Automatically added by buildreq on Fri May 18 2007
#BuildRequires: esound fontconfig gcc-c++ glibc-devel-static gtk+-devel imake libavcodec-devel libdvdread-devel libfame-devel libfreetype-devel libglut-devel libImageMagick-devel liblzo-devel libmesa-devel libmjpegtools-devel libmpeg2-devel libnetpbm-devel libpostproc-devel libquicktime-devel libSDL-devel libXaw-devel libXi-devel libxml2-devel libXv-devel svgalib xorg-cf-files

BuildRequires: gcc-c++ zlib-devel bzlib-devel
BuildRequires: libXaw-devel libXv-devel libXi-devel
%{?_with_X11:BuildRequires: xorg-cf-files}

# libmpeg2
BuildRequires: libmpeg2-devel

# ffmpeg (libavcodec)
%if_enabled static_libavcodec
BuildRequires: glibc-devel-static libxvid-devel-static
#BuildRequires: libavcodec-devel-static >= 0.4.9
#BuildRequires: libavutil-devel-static >= 0.4.9
BuildRequires: libffmpeg-devel-static >= 0.4.9
%else
BuildRequires: libavcodec-devel >= 0.4.9
%endif
%{?_enable_postproc:BuildRequires: libpostproc-devel}
%{?_enable_libmpeg3:BuildRequires: libmpeg3-devel}
%{?_enable_quicktime:BuildRequires: libquicktime-devel}
%{?_enable_avifile:BuildRequires: libavifile-devel}
%{?_enable_theora:BuildRequires: libtheora-devel}
%{?_enable_mjpegtools:BuildRequires: libmjpegtools-devel}
%{?_enable_libfame:BuildRequires: libfame-devel}

%{?_enable_imagemagick:BuildRequires: libImageMagick-devel fontconfig}
%{?_enable_jpeg:BuildRequires: libjpeg-devel}

%{?_enable_lame:BuildRequires: liblame-devel >= 3.89}
%{?_enable_ogg:BuildRequires: libogg-devel}
%{?_enable_vorbis:BuildRequires: libvorbis-devel}
%{?_enable_a52:BuildRequires: liba52-devel}

%{?_enable_sdl:BuildRequires: esound libSDL-devel >= 1.1.6}

%{?_enable_dvd:BuildRequires: libdvdread-devel}
%{?_enable_dv:BuildRequires: libdv-devel}

%{?_enable_libxml2:BuildRequires: libxml2-devel}
%{?_enable_freetype:BuildRequires: libfreetype-devel >= 2}
%{?_enable_gtk:BuildRequires: gtk+-devel}

%{?_enable_lzo:BuildRequires: liblzo-devel}

%{?_enable_xio:BuildRequires: libxio-devel}
%{?_enable_pvm:BuildRequires: libpvm-devel >= 3.4}

%{?_with_showpvn_gl:BuildRequires: libglut-devel libmesa-devel}
%if_with showpvn_imagemagick
BuildRequires: fontconfig-devel libImageMagick-devel libjpeg-devel
BuildRequires: liblcms-devel libtiff-devel
%endif
%{?_with_subtitleripper:BuildRequires: libnetpbm-devel libpng-devel}

%description
transcode  is a linux text-console utility for video stream processing.
Decoding and encoding is done by loading modules that are responsible
for feeding transcode with raw video/audio streams (import modules) and
encoding the frames (export modules).
It supports elementary video and audio frame transformations, including
de-interlacing or fast resizing of video frames and loading of external
filters.
A number of modules are included to enable import of DVDs on-the-fly,
MPEG elementary (ES) or program streams (VOB), MPEG video, Digital
Video (DV), YUV4MPEG streams, NuppelVideo file format and raw or
compressed (pass-through) video frames and export modules for writing
DivX;-), OpenDivX, DivX 4.xx or uncompressed AVI files with MPEG, AC3
(pass-through) or PCM audio. Additional export modules to write single
frames (PPM) or YUV4MPEG streams are available, as well as an interface
import module to the avifile library. It's modular concept is intended
to provide flexibility and easy user extensibility to include other
video/audio codecs or filetypes.
A set of tools is included to demux (tcdemux), extract (tcextract) and
decode (tcdecode) the sources into raw video/audio streams for import,
probing (tcprobe) and scanning (tcscan) your sources and to enable
post-processing of AVI files, fixing AVI file header information
(avifix), merging multiple files (avimerge) or splitting large AVI files
(avisplit) to fit on a CD.


%if_with pnmpvn
%package -n pvn-utils
Summary: Utils for PVN files
Group: Video

%description -n pvn-utils
Utils for PVN files.
%endif


%if_with subtitleripper
%package -n subtitleripper
Summary: DVD subtitles ripper/converter
Group: Video
Requires: %name

%description -n subtitleripper
This package contains tools to extract DVD subtitles from a subtitle
stream and converts it to pgm or ppm images or into VobSub format.
%endif


%prep
%setup -q -a 1
mv subtitleripper contrib
%patch0 -p1
%patch4 -p0
%patch5 -p1
subst 's/ libavcodec\.a/libav{codec,util}.a `$PKG_CONFIG --libs libavcodec`/' configure.in
gzip -dc -- %SOURCE2 > filter/export_draw.c
sed -i -e 's/ -lm \(-[^l].*\)$/ \1 -lm/' -e 's/^GLLIBS/LOPENGL/' contrib/pnmpvn/makefile-pvn
cd contrib/subtitleripper
%patch101 -p1
%patch102 -p1


%build
%define _optlevel 3
%__autoreconf
%configure \
    %{subst_with pic} \
    %{subst_enable shared} \
    %{subst_enable static} \
    %{subst_enable mmx} \
    %{subst_enable sdnow} \
    %{subst_enable sse} \
    %{subst_enable sse2} \
    %{subst_enable altivec} \
    %{subst_enable libavcodec} \
    %{subst_enable_to static_libavcodec libavcodec-static} \
    --with-libavcodec-libs=%_libdir \
    %{subst_enable_to postproc libpostproc} \
    %{subst_enable libmpeg2} \
    %{subst_enable libmpeg3} \
    %{subst_enable avifile} \
    %{subst_enable theora} \
    %{subst_enable mjpegtools} \
    %{subst_enable libfame} \
    %{subst_enable_to quicktime libquicktime} \
    %{subst_enable imagemagick} \
    --disable-libjpegmmx \
    %{subst_enable_to jpeg libjpeg} \
    %{subst_enable lame} \
    %{subst_enable ogg} \
    %{subst_enable vorbis} \
    %{subst_enable a52} \
    %{subst_enable_to static_framebuffer statbuffer} \
    %{subst_enable sdl} \
    %{subst_enable oss} \
    %{subst_enable_to sunaudio sanau} \
    %{subst_enable netstream} \
    %{subst_enable v4l} \
    %{subst_enable bktr} \
    %{subst_enable lzo} \
    %{subst_enable_to dvd libdvdread} \
    %{subst_enable_to dv libdv} \
    %{subst_enable libxml2} \
    %{subst_enable_to freetype freetype2} \
    %{subst_enable gtk} \
    %{subst_enable iconv} \
    %{subst_enable ibp} \
    %{subst_enable bsdav} \
    %{subst_enable xio} \
    %{subst_enable_to pvm pvm3} \
    %{subst_with_to X11 x}

# SMP-incompatible build
%make_build
%{?_with_subtitleripper:%make_build -C contrib/subtitleripper COPT="%optflags"}
%{?_with_pnmpvn:%make_build -C contrib/pnmpvn -f makefile-pvn CFLAGS="%optflags"}
%{?_with_showpvn_gl:%make_build -C contrib/pnmpvn -f makefile-pvn CFLAGS="%optflags" showpvn}
%{?_with_showpvn_imagemagick:%make_build -C contrib/pnmpvn -f makefile-pvn CFLAGS="%optflags" showpvn-Magick}


%install
%make_install DESTDIR=%buildroot install
mv %buildroot%_docdir/%name{,-%version}
install -m 0644 AUTHORS README TODO %buildroot%_docdir/%name-%version/
bzip2 --best --force %buildroot%_docdir/%name-%version/ChangeLog
%{?_disable_xvid:rm -f %buildroot%_docdir/%name-%version/README.xvid*}
%{?_disable_dv:rm -f %buildroot%_docdir/%name-%version/{README.dv,DV-to-DVD-HOWTO.txt}}
%{?_disable_dvd:rm -f %buildroot%_docdir/%name-%version/README.rip}
%{?_disable_pvm:rm -f %buildroot%_docdir/%name-%version/{export_pvm.txt,pvm.cfg}}
%{?_disable_ibp:rm -f %buildroot%_docdir/%name-%version/ibp_support.txt}
%{?_disable_libxml2:rm -f %buildroot%_docdir/%name-%version/import-xml.txt}
%{?_disable_v4l:rm -f %buildroot%_docdir/%name-%version/import_{nvrec,v4l2}.txt}
%{?_with_subtitleripper:install -m 0755 contrib/subtitleripper/{srttool,subtitle2{pgm,vobsub},pgm2txt,vobsub2pgm} %buildroot/%_bindir/}
%{?_with_pnmpvn:install -m 0755 contrib/pnmpvn/{pnm2pvn,pvn{2pnm,convert}} %buildroot/%_bindir/}
%if_with showpvn_gl
install -m 0755 contrib/pnmpvn/showpvn %buildroot/%_bindir/showpvn-gl
ln -s showpvn-gl %buildroot/%_bindir/showpvn
%endif
%if_with showpvn_imagemagick
install -m 0755 contrib/pnmpvn/showpvn-Magick %buildroot/%_bindir/showpvn-im
test -L %buildroot/%_bindir/showpvn || ln -s showpvn-im %buildroot/%_bindir/showpvn
%endif
rm -f %buildroot%_libdir/%name/*.la

%{?_enable_shared:%add_findprov_lib_path %_libdir/%name}


%files
%_docdir/%name-%version
%_bindir/%name
%_bindir/avi*
%_bindir/tc*
%dir %_libdir/%name
%_libdir/%name/*.so
%_libdir/%name/*.conf
%_libdir/%name/*.cfg
%_libdir/%name/*.awk
%_man1dir/*


%if_with pnmpvn
%files -n pvn-utils
%doc contrib/pnmpvn/*.html
%_bindir/*pvn*
%endif


%if_with subtitleripper
%files -n subtitleripper
%doc contrib/subtitleripper/README* contrib/subtitleripper/ChangeLog
%_bindir/srttool
%_bindir/subtitle2pgm
%_bindir/subtitle2vobsub
%_bindir/pgm2txt
%_bindir/vobsub2pgm
%endif


%changelog
* Sat Dec 22 2007 Led <led@altlinux.ru> 1.0.4-alt0.1
- 1.0.4

* Fri May 18 2007 Led <led@altlinux.ru> 1.0.3-alt0.1
- 1.0.3
- updated %name-1.0.3-configure_ffmpeg.patch
- removed filter_compare-fixes-try2.patch
- removed filter_logo-hangup-try1.patch
- removed filter-fix-try2.patch
- updated BuildRequires

* Wed Feb 28 2007 Led <led@altlinux.ru> 1.0.2-alt3.3.4
- disabled jpeg-mmx

* Thu Feb 08 2007 Led <led@altlinux.ru> 1.0.2-alt3.3.3
- rebuild with libfame 0.9.1

* Thu Nov 02 2006 Led <led@altlinux.ru> 1.0.2-alt3.3.2
- disabled libjpegmmx for non-%%ix86 archs

* Thu Nov 02 2006 Led <led@altlinux.ru> 1.0.2-alt3.3.1
- rebuild with new libmjpegtools

* Wed Sep 20 2006 Led <led@altlinux.ru> 1.0.2-alt3.2.3
- added %name-1.0.0-dirac-0.5.x.patch for support Dirac via FFmpeg

* Tue Sep 19 2006 Led <led@altlinux.ru> 1.0.2-alt3.2.2
- fixed BuildRequires
- enabled some options
- anabled pnmpvn and added package pvn-utils
- fixed and updated some patches

* Thu Sep 14 2006 Led <led@altlinux.ru> 1.0.2-alt3.2.1
- rebuild with new libfame

* Thu Aug 10 2006 L.A. Kostis <lakostis@altlinux.ru> 1.0.2-alt3.2
- fix v4l support;
- fix new ffmpeg detection;
- update buildrequires;
- remove xorg-x11-devel and replace it more less libs.

* Wed May 24 2006 LAKostis <lakostis at altlinux.ru> 1.0.2-alt3.1
- Rebuild w/ new ffmpeg.
- Add xorg-x11-devel for compiling filter_subtitler.

* Wed Apr 12 2006 LAKostis <lakostis at altlinux.ru> 1.0.2-alt3
- Added patches from official Bug Showcase:
  + filter_compare-fixes-try2.patch (more correct than my patch)
  + filter_logo-hangup-try1.patch
  + filter-fix-try2.patch
  + tccat-CVS-iodir-backport-try1.patch
- Added sources from official Bug Showcase:
  + export_pcm.c - fix dvraw export module causes segfault 
  		   whan transcoding dv NTSC -> PAL

* Fri Mar 17 2006 LAKostis <lakostis@altlinux.ru> 1.0.2-alt2.2
- patch subtitleripper against new --as-needed ld flag.

* Tue Jan 24 2006 LAKostis <lakostis@altlinux.ru> 1.0.2-alt2.1
- change package maintainer.
- cleanup buildrequires.
- backported imagemagick support fix from CVS.

* Tue Jan 24 2006 Vitaly Lipatov <lav@altlinux.ru> 1.0.2-alt2
- rebuild without imagemagick support (due dvdrip problems)

* Sun Dec 18 2005 Vitaly Lipatov <lav@altlinux.ru> 1.0.2-alt1
- rebuild without glib1/gtk+1/gnome1 libraries (gtk support)

* Wed Nov 16 2005 Vitaly Lipatov <lav@altlinux.ru> 1.0.2-alt0.1
- new version
- change Packager
- add patch for subtitleripper against new libnetpbm 

* Tue Sep 20 2005 Vitaly Lipatov <lav@altlinux.ru> 1.0.0-alt0.1
- NMU: new version (fix bug #7947)
- build with quicktime (fix code by subst)

* Wed Jan 19 2005 Yuri N. Sedunov <aris@altlinux.ru> 0.6.14-alt1.1
- rebuild against mjpegtools-1.7.0.
- quicktime support temporarily disabled, not ready for libquicktime-0.9.4

* Wed Dec 22 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.14-alt1
- 0.6.14

* Thu Nov 11 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.13-alt1
- 0.6.13

* Sun Jul 18 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.12-alt1.3
- rebuild with theora support.

* Mon Jun 07 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.12-alt1.2
- rebuild against libdv-0.102

* Fri May 14 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.12-alt1.1
- fixed build.

* Fri Jan 09 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.6.12-alt1
- 0.6.12

* Fri Dec 05 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.11-alt2
- rebuild with new libImageMagick.

* Fri Nov 07 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.11-alt1
- 0.6.11

* Fri Sep 12 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.10-alt2
- rebuild due ImageMagick depends on new libexif-0.5.12.

* Tue Sep 09 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.10-alt1
- 0.6.10

* Sun Aug 24 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.9-alt1
- new version.
- enable building libmpeg3 dependent modules.

* Fri Jul 11 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.8-alt1
- new version

* Wed May 28 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.6-alt1
- new version

* Mon Mar 03 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.3-alt2
- subtitleripper subpackage.

* Mon Feb 24 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.6.3-alt1
- 0.6.3

* Sun Nov 24 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.6.2-alt1
- 0.6.2

* Wed Nov 20 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.6.1-alt0.7
- Updated from weekly snapshot.
- Removed dependence on libmpeg3 which is replaced by the libmpeg2
  dependent modules that are included in transcode's sources.
- Compression support based on liblzo enabled.
- Quicktime support via libquicktime enabled.

* Wed Sep 25 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.6.1-alt0.6
- 0.6.1

* Mon Sep 23 2002 Stanislav Ievlev <inger@altlinux.ru> 0.6.0-alt0.5.1
- fix build (no SMP compatible)

* Sun Sep 22 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.6.0-alt0.5
- 0.6.0 release

* Sun Jul 21 2002 Yuri N. Sedunov <aris@altlinux.ru> 0.6.0-alt0.1rc3
- First build for Sisyphus.
- quicktime support disabled - libquicktime required.
